from ngsolve import *
from netgen.geom2d import unit_square

mesh = Mesh(unit_square.GenerateMesh(maxh=0.4))

cf_normal = x
dcf_normal = cf_normal.Diff(x)


fes = H1(mesh, order=2)
gf = GridFunction(fes)
gf.Set(x)

cf = 1*gf
dcf = cf.Diff(x)


print("\nExpected behaviour:")
print("Function:")
print(cf_normal(mesh(0,0)))
print(cf_normal(mesh(0.5,0.5)))
print("Derivative:")
print(dcf_normal(mesh(0,0)))
print(dcf_normal(mesh(0.5,0.5)))


print("\nUnexpected behaviour derivative:")
print("Function:")
print(cf(mesh(0,0)))
print(cf(mesh(0.5,0.5)))
print("Derivative:")
print(dcf(mesh(0,0)))
print(dcf(mesh(0.5,0.5)))